#include <Arduino.h>
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>

#define LED 2

// See the following for generating UUIDs:
// https://www.uuidgenerator.net/
#define BLUETOOTH_NAME "AGV"
#define SERVICE_UUID "6E400001-B5A3-F393-E0A9-E50E24DCCA9E"  // UART service UUID
#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9E"
#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9E"

//#############################################################################//

BLEServer *pServer = NULL;
BLECharacteristic *pTxCharacteristic;
bool deviceConnected = false;
bool oldDeviceConnected = false;
int txValue;




extern void pulsarArriba();
extern void soltarArriba();
extern void pulsarDerecha();
extern void soltarDerecha();
extern void pulsarIzquierda();
extern void soltarIzquierda();
extern void pulsarAbajo();
extern void soltarAbajo();
extern void mantener_posicion();
extern void cambio_modo();
extern void velocidad_lenta();
extern void velocidad_media();
extern void velocidad_rapida();

class MyServerCallbacks : public BLEServerCallbacks {
  void onConnect(BLEServer *pServer) {
    deviceConnected = true;
    digitalWrite(LED, HIGH);
  };

  void onDisconnect(BLEServer *pServer) {
    deviceConnected = false;
    digitalWrite(LED, LOW);
  }
};

class MyCallbacks : public BLECharacteristicCallbacks {
  void onWrite(BLECharacteristic *pCharacteristic) {
    std::string rxValue = pCharacteristic->getValue();

    if (rxValue.length() > 0) {
      //Serial.println("***");
      //Serial.print("Received Value: ");
      for (int i = 0; i < rxValue.length(); i++)
        //Serial.print(rxValue[i]);

        //Serial.println();
        //Serial.println("***");
        //mantener_posicion();
      /*if (rxValue == "!B11:") {
        if (modo_manual == true) {
          modo_manual == false;
        cambio_modo();
        Serial.println("cambio");
        } else {
          modo_manual == true;
        }
      } else */if (rxValue == "!B516") {  // arriba
        pulsarArriba();
      } else if (rxValue == "!B507") {  // soltar arriba
        soltarArriba();
      }
      if (rxValue == "!B813") {  // derecha
        pulsarDerecha();
      } else if (rxValue == "!B804") {  // soltar derecha
        soltarDerecha();
      } else if (rxValue == "!B714") {  // izquierda
        pulsarIzquierda();
      } else if (rxValue == "!B705") {  // soltar izquierda
        soltarIzquierda();
      } else if (rxValue == "!B615") {  // Abajo
        pulsarAbajo();
      } else if (rxValue == "!B606") {  // soltar Abajo
        soltarAbajo();
      } else if (rxValue == "!B11:") {  // pulsar 1
        cambio_modo();
      } else if (rxValue =="!B10;") {
        mantener_posicion();
      } else if (rxValue == "!B219") {  // soltar Abajo
        velocidad_lenta();
      } else if (rxValue == "!B318") {  // soltar Abajo
        velocidad_media();
      } else if (rxValue == "!B417") {  // soltar Abajo
        velocidad_rapida();
      } 
    }
  }
};

void setupBluetooth() {
  // Serial.begin(115200);
  // Create the BLE Device
  BLEDevice::init(BLUETOOTH_NAME);

  // Create the BLE Server
  pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());

  // Create the BLE Service
  BLEService *pService = pServer->createService(SERVICE_UUID);

  // Create a BLE Characteristic
  pTxCharacteristic = pService->createCharacteristic(
    CHARACTERISTIC_UUID_TX,
    BLECharacteristic::PROPERTY_NOTIFY);

  pTxCharacteristic->addDescriptor(new BLE2902());

  BLECharacteristic *pRxCharacteristic = pService->createCharacteristic(
    CHARACTERISTIC_UUID_RX,
    BLECharacteristic::PROPERTY_WRITE);

  pRxCharacteristic->setCallbacks(new MyCallbacks());

  // Start the service
  pService->start();

  // Start advertising
  pServer->getAdvertising()->start();
  //Serial.println("Waiting a client connection to notify...");
}

void loopBluetooth() {
  if (deviceConnected) {
    // pTxCharacteristic->setValue(&Kidsy.ColorSensor.value, 1);
    // pTxCharacteristic->notify();
    delay(10);  // bluetooth stack will go into congestion, if too many packets are sent
  }

  // disconnecting
  if (!deviceConnected && oldDeviceConnected) {
    delay(500);                   // give the bluetooth stack the chance to get things ready
    pServer->startAdvertising();  // restart advertising
    //Serial.println("start advertising");
    oldDeviceConnected = deviceConnected;
  }
  // connecting
  if (deviceConnected && !oldDeviceConnected) {
    // do stuff here on connecting
    oldDeviceConnected = deviceConnected;
  }
}

