


#include <ESP32Servo.h>


Servo velocidad_derecha; //Señal PWM que controla el acelerador
Servo velocidad_izquierda; //Señal PWM que controla el acelerador

Servo direccion_derecha; //Señal PWM que controla la dirección (volante)
Servo direccion_izquierda; //Señal PWM que controla la dirección (volante)

bool bandera_movimiento = false;  //Variable que sirve para que la rampa de arranque sólo se ejecute si el AGV está detenido

void configurarDispositivos() {
  // Configuraciones de dispositivos
 velocidad_izquierda.attach(18);
 direccion_izquierda.attach(5);

 direccion_derecha.attach(21);
 velocidad_derecha.attach(19);
 // Serial.begin(9600);
}




void retroceder(int vel) { //Funcion para avanzar, hay que pasarle un valor de 0 a 100 


//direccion_derecha.writeMicroseconds(1500);//Enderezamos la dirección (centramos el volante)
//direccion_izquierda.writeMicroseconds(1500);

  int velocidad_mapeada_der = map(vel, 0, 100, 1500, 1000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente
 int velocidad_mapeada_iz = map(vel, 0, 100, 1500, 2000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente



if(bandera_movimiento==false) //Si el AGV está detenido realizamos una rampa de aceleración para no forzar los motores
{
  for(int i=0; i<velocidad_mapeada_iz-1500; i++)
  {
direccion_derecha.writeMicroseconds(1500-i);
direccion_izquierda.writeMicroseconds(1500+i);
    //  Serial.println(1500+i);
    delay(3);

  }

  bandera_movimiento=true;
}
else{ //Si el AGV está en movimiento directamente mantenemos la velocidad*/
direccion_derecha.writeMicroseconds(velocidad_mapeada_der);
direccion_izquierda.writeMicroseconds(velocidad_mapeada_iz);
}

  
  

}

void avanzar(int vel) { //Funcion para retroceder, hay que pasarle un valor de 0 a 100 

//direccion_derecha.writeMicroseconds(1500);//Enderezamos la dirección (centramos el volante)
//direccion_izquierda.writeMicroseconds(1500);

  int velocidad_mapeada_der = map(vel, 0, 100, 1500, 2000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente
 int velocidad_mapeada_iz = map(vel, 0, 100, 1500, 1000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente



if(bandera_movimiento==false) //Si el AGV está detenido realizamos una rampa de aceleración para no forzar los motores
{
  for(int i=0; i<velocidad_mapeada_der-1500; i++)
  {

direccion_derecha.writeMicroseconds(1500+i);
direccion_izquierda.writeMicroseconds(1500-i);
    //  Serial.println(1500+i);
    delay(3);

  }

  bandera_movimiento=true;
}
else{ //Si el AGV está en movimiento directamente mantenemos la velocidad

}

  

}

void pivotar_izquierda(int vel) {

//velocidad_derecha.writeMicroseconds(1500); //Ponemos la velocidad a 0. Marcar una velocidad en la dirección y otra en que no sea 0 en la velocidad puede producir efectos no deseados. Cuando se gire es mejor utilizar sólo la funcion de girar
//velocidad_izquierda.writeMicroseconds(1500); 
//delay(200);

  int velocidad_mapeada = map(vel, 0, 100, 1500, 1000); //Convertimos la dirección al rango 1500-2000 que equivalen a no girar y a girar al máximo a la izquierda respectivamente
if(bandera_movimiento==false) //Si el AGV está detenido realizamos una rampa de aceleración para no forzar los motores
{
  for(int i=0; i<1500-velocidad_mapeada; i++)
  {

direccion_derecha.writeMicroseconds(1500-i);
direccion_izquierda.writeMicroseconds(1500-i);
    //  Serial.println(1500+i);
    delay(2);

  }
//direccion_derecha.writeMicroseconds(1000);
//direccion_izquierda.writeMicroseconds(1000);

bandera_movimiento=true;
 }

}

void pivotar_derecha(int vel) {

velocidad_derecha.writeMicroseconds(1500);  //Ponemos la velocidad a 0. Marcar una velocidad en la dirección y otra en que no sea 0 en la velocidad puede producir efectos no deseados. Cuando se gire es mejor utilizar sólo la funcion de girar
velocidad_izquierda.writeMicroseconds(1500); 
//delay(200);

  int velocidad_mapeada = map(vel, 0, 100, 1500, 2000); //Convertimos la dirección al rango 1500-2000 que equivalen a no girar y a girar al máximo a la derecha respectivamente

if(bandera_movimiento==false) //Si el AGV está detenido realizamos una rampa de aceleración para no forzar los motores
{
  for(int i=0; i<velocidad_mapeada-1500; i++)
  {

direccion_derecha.writeMicroseconds(1500+i);
direccion_izquierda.writeMicroseconds(1500+i);
    //  Serial.println(1500+i);
    delay(2);

  }

//direccion_derecha.writeMicroseconds(2000);
//direccion_izquierda.writeMicroseconds(2000);
bandera_movimiento=true;
  }



}

void detenerse() {

bandera_movimiento=false; //Ponemos a 0 la bandera para indicar que el AGV está detenido

velocidad_derecha.writeMicroseconds(1500); //Ponemos la velocidad a 0 (1500 equivale a no moverse)
velocidad_izquierda.writeMicroseconds(1500);

direccion_derecha.writeMicroseconds(1500); //Fijamos la dirección a 0 (1500 equivale a no girar, si no tratará de pivotar)
direccion_izquierda.writeMicroseconds(1500);
delay(10); 


}


void girar(int vel_iz, int vel_der) {

//direccion_derecha.writeMicroseconds(1500);//Enderezamos la dirección (centramos el volante)
//direccion_izquierda.writeMicroseconds(1500);

  int velocidad_mapeada_der = map(vel_der, 0, 100, 1500, 2000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente
 int velocidad_mapeada_iz = map(vel_iz, 0, 100, 1500, 1000); //Convertimos la velocidad al rango 1500-2000 que equivalen a estar detenido y a velocidad máxima respectivamente



/*if(bandera_movimiento==false) //Si el AGV está detenido realizamos una rampa de aceleración para no forzar los motores
{
  for(int i=0; i<velocidad_mapeada-1500; i++)
  {
    velocidad_derecha.writeMicroseconds(1500+i); 
    velocidad_izquierda.writeMicroseconds(1500+i); 
    //  Serial.println(1500+i);

  }

  bandera_movimiento=true;
}
else{ //Si el AGV está en movimiento directamente mantenemos la velocidad*/
direccion_derecha.writeMicroseconds(velocidad_mapeada_der);
direccion_izquierda.writeMicroseconds(velocidad_mapeada_iz);
//}

  

}



